//	MH****************************************************
//	Copyright (c) 2004 Siemens AG - Com ESY HD 631 Witten
//	Copyright (c) 2003 Siemens AG - ICN EN HS D 631 Witten
//	Copyright (c) 2002 Siemens AG - ICN EN HO SE 5 Witten
//	Copyright (c) 2001 Siemens AG - ICN EN HO SE 5 Witten
//	Copyright (c) 2000 Siemens AG - ICN EN HO SE 5 Witten
//	Copyright (c) 2000 Siemens AG - ICN WN BS SE 5 Witten
//	Copyright (c) 1999 Siemens AG - ICN WN BS SE 5 Witten
//
//	Telephony Service Provider for MiWindows NT
//
//	Module Name:	Siemens.h
//
//	Archive Name:	
//
//	Description:	This is a include file for all Siemens 1stParty TSP's and TAPI applications
//	
//	Author:		various
//
//	HOC*********************************************************************
//	Date     | Comments						| Name
//	---------+------------------------------------------------------+-------
//	12.09.99 | initial creation					| mar
//	         | #define SIEMENSLINE_DIAL_DIGITS added		| mar
//	         | #define SIEMENS_MAX_DIALABLE_STRING_BYTES added	| mar
//	         | struct SIEMENS_LINE_DEV_SPECIFIC created		| mar
//	         | #pragma pack						| mar
//	13.09.99 | struct SIEMENS_LINEDEVCAPS_DEV_SPECIFIC created	| mar
//	22.09.99 | Add new feature values (53-57)			| M. Doelle
//	23.09.99 | #defines for ring modes added			| mar
//	08.10.99 | struct SIEMENS_PHONESTATUS_DEV_SPECIFIC created	| mar
//	02.11.99 | #defines for SIEMENSBUTTONFUNCTION_xxx added		| mar
//	04.11.99 | struct SIEMENS_LINEDEVSTATUS_DEV_SPECIFIC created	| mar
//	23.07.01 | Add new feature value (52)				| B. Farkas
//	xx.yy.zz | Add new DEV_SPECIFIC					| B. Gronostay
//	22.12.03 | Add new feature values x80000051 - x80000050		| P. Halacz
//	05.01.04 | Add new feature values x8000004F - x8000004E		| P. Halacz
//	26.01.04 | Add new feature values x8000004D			| P. Halacz
//	28.01.04 | Add new feature values x8000004C - x8000003C		| P. Halacz
//	19.02.04 | Include-Guards added					| Jaraczewski
//	20.02.04 | Add new feature values x8000003B - x8000002B		| P. Halacz
//	16.04.04 | Add new feature values x8000002A - x8000001A		| P. Halacz
//	28.04.04 | Add new DEV_SPECIFIC					| P. Halacz
//	01.09.04 | Add new DEV_SPECIFIC & new feature value x80000019	| P. Halacz
//	28.09.04 | Add new feature values x80000018 - x80000017		| P. Halacz
//	         |							|
//	************************************************************************
#ifndef __SIEMENS_H__
#define __SIEMENS_H__

#pragma pack(push, include_siemens)		// store previos packing alingment
#pragma pack(1)					// packing alingment: 1 byte

//------------------------------------------------------------------------------
// Siemens Service Provider extensions to the PHONEBUTTONFUNCTION values
//------------------------------------------------------------------------------

// Decrement this value whenever new features are added

#define DB_FIRST_SIEMENSBUTTONFUNCTION				0x80000017

#define SIEMENSBUTTONFUNCTION_CALLWAITWTONEOFF			0x80000017
#define SIEMENSBUTTONFUNCTION_CALLWAITWTONEON			0x80000018

#define SIEMENSBUTTONFUNCTION_CONFQUIT				0x80000019

#define SIEMENSBUTTONFUNCTION_MSGWAIT_CANCEL_TERMIN		0x8000001A
#define SIEMENSBUTTONFUNCTION_MSGWAIT_CANCEL_ORIGIN		0x8000001B
#define SIEMENSBUTTONFUNCTION_MSGWAIT_ACTIVATE			0x8000001C
#define SIEMENSBUTTONFUNCTION_SECRSUBSTITUTEOFF			0x8000001D
#define SIEMENSBUTTONFUNCTION_SECRSUBSTITUTEON			0x8000001E
#define SIEMENSBUTTONFUNCTION_SECRINTERCEPT4OFF			0x8000001F
#define SIEMENSBUTTONFUNCTION_SECRINTERCEPT4ON			0x80000020
#define SIEMENSBUTTONFUNCTION_SECRINTERCEPT3OFF			0x80000021
#define SIEMENSBUTTONFUNCTION_SECRINTERCEPT3ON			0x80000022
#define SIEMENSBUTTONFUNCTION_SECRINTERCEPT2OFF			0x80000023
#define SIEMENSBUTTONFUNCTION_SECRINTERCEPT2ON			0x80000024
#define SIEMENSBUTTONFUNCTION_SECRINTERCEPT1OFF			0x80000025
#define SIEMENSBUTTONFUNCTION_SECRINTERCEPT1ON			0x80000026
#define SIEMENSBUTTONFUNCTION_CLIROFF				0x80000027
#define SIEMENSBUTTONFUNCTION_CLIRON				0x80000028
#define SIEMENSBUTTONFUNCTION_MAINMENUOFF			0x80000029
#define SIEMENSBUTTONFUNCTION_MAINMENUON			0x8000002A

#define SIEMENSBUTTONFUNCTION_ACDNIGHTSRVOFF			0x8000002B
#define SIEMENSBUTTONFUNCTION_ACDNIGHTSRVON			0x8000002C
#define SIEMENSBUTTONFUNCTION_AGTMODERDY			0x8000002D
#define SIEMENSBUTTONFUNCTION_AGTLOGOFF				0x8000002E
#define SIEMENSBUTTONFUNCTION_MESSAGEANSWEROFF			0x8000002F
#define SIEMENSBUTTONFUNCTION_MESSAGEANSWERON			0x80000030
#define SIEMENSBUTTONFUNCTION_PRIVACYOFF			0x80000031
#define SIEMENSBUTTONFUNCTION_PRIVACYON				0x80000032
#define SIEMENSBUTTONFUNCTION_CLIPOFF				0x80000033
#define SIEMENSBUTTONFUNCTION_CLIPON				0x80000034
#define SIEMENSBUTTONFUNCTION_STARTHUNT				0x80000035
#define SIEMENSBUTTONFUNCTION_CODELOCKOFF			0x80000036
#define SIEMENSBUTTONFUNCTION_CODELOCKON			0x80000037
#define SIEMENSBUTTONFUNCTION_CALLBACKGET			0x80000038
#define SIEMENSBUTTONFUNCTION_CALLBACKSET			0x80000039
#define SIEMENSBUTTONFUNCTION_NIGHTSRVOFF			0x8000003A
#define SIEMENSBUTTONFUNCTION_NIGHTSRVON			0x8000003B

#define SIEMENSBUTTONFUNCTION_ACCOUNTCODE			0x8000003C
#define SIEMENSBUTTONFUNCTION_UNPARKGROUP			0x8000003D
#define SIEMENSBUTTONFUNCTION_PROGRAMSERVICEMODEOFF		0x8000003E
#define SIEMENSBUTTONFUNCTION_PROGRAMSERVICEMODEON		0x8000003F
#define SIEMENSBUTTONFUNCTION_SYSUNPARK				0x80000040
#define SIEMENSBUTTONFUNCTION_SYSPARK				0x80000041
#define SIEMENSBUTTONFUNCTION_CONFREMP8				0x80000042
#define SIEMENSBUTTONFUNCTION_CONFREMP7				0x80000043
#define SIEMENSBUTTONFUNCTION_CONFREMP6				0x80000044
#define SIEMENSBUTTONFUNCTION_CONFREMP5				0x80000045
#define SIEMENSBUTTONFUNCTION_CONFREMP4				0x80000046
#define SIEMENSBUTTONFUNCTION_CONFREMP3				0x80000047
#define SIEMENSBUTTONFUNCTION_CONFREMP2				0x80000048
#define SIEMENSBUTTONFUNCTION_CONFREMP1				0x80000049
#define SIEMENSBUTTONFUNCTION_CONSULTATION			0x8000004A
#define SIEMENSBUTTONFUNCTION_HEADSETOFF			0x8000004B
#define SIEMENSBUTTONFUNCTION_HEADSETON				0x8000004C

#define SIEMENSBUTTONFUNCTION_CALLWAITINGDEACT			0x8000004D

#define SIEMENSBUTTONFUNCTION_DNDOFF				0x8000004E
#define SIEMENSBUTTONFUNCTION_DNDON				0x8000004F

#define SIEMENSBUTTONFUNCTION_MUTEOFF				0x80000050
#define SIEMENSBUTTONFUNCTION_MUTEON				0x80000051

#define SIEMENSBUTTONFUNCTION_CDRACCOUNTCODE			0x80000052
#define SIEMENSBUTTONFUNCTION_RINGERCUTOFF			0x80000053
#define SIEMENSBUTTONFUNCTION_PRIVATE				0x80000054
#define SIEMENSBUTTONFUNCTION_ACDNIGHTANSWER			0x80000055
#define SIEMENSBUTTONFUNCTION_GENCALLKEY			0x80000056
#define SIEMENSBUTTONFUNCTION_SELECTLANGUAGE			0x80000057

#define SIEMENSBUTTONFUNCTION_REMOTEFLASH			0x80000058
#define SIEMENSBUTTONFUNCTION_DIALPADKEYA			0x80000059
#define SIEMENSBUTTONFUNCTION_DIALPADKEYB			0x80000060
#define SIEMENSBUTTONFUNCTION_DIALPADKEYC			0x80000061
#define SIEMENSBUTTONFUNCTION_DIALPADKEYD			0x80000062
#define SIEMENSBUTTONFUNCTION_ABSENT				0x80000063
#define SIEMENSBUTTONFUNCTION_HELP				0x80000064
#define SIEMENSBUTTONFUNCTION_RECORDCHARGES			0x80000065
#define SIEMENSBUTTONFUNCTION_MAIL				0x80000066
#define SIEMENSBUTTONFUNCTION_STORETEXT				0x80000067
#define SIEMENSBUTTONFUNCTION_CALLINGNAMEID			0x80000068
#define SIEMENSBUTTONFUNCTION_ATNDTRANSFER			0x80000069
#define SIEMENSBUTTONFUNCTION_ATNDNOTAVAIL			0x8000006A
#define SIEMENSBUTTONFUNCTION_ALTCONTACT			0x8000006B
#define SIEMENSBUTTONFUNCTION_BUSYINDICATOR			0x8000006C
#define SIEMENSBUTTONFUNCTION_ATNDQUEUE				0x8000006D
#define SIEMENSBUTTONFUNCTION_PLUSMINUS				0x8000006E
#define SIEMENSBUTTONFUNCTION_ACDAVAILTOGGLE			0x8000006F
#define SIEMENSBUTTONFUNCTION_MAILBOXMENU			0x80000070
#define SIEMENSBUTTONFUNCTION_VARFWDPOSTDIAL			0x80000071
#define SIEMENSBUTTONFUNCTION_SYSTERMMODE			0x80000072
#define SIEMENSBUTTONFUNCTION_FWDMENU				0x80000073
#define SIEMENSBUTTONFUNCTION_CAFLOGOFF				0x80000074
#define SIEMENSBUTTONFUNCTION_CAFGPLOGOFF			0x80000075
#define SIEMENSBUTTONFUNCTION_CAFAVAIL				0x80000076
#define SIEMENSBUTTONFUNCTION_CAFGPAVAIL			0x80000077
#define SIEMENSBUTTONFUNCTION_CAFUNAVAIL			0x80000078
#define SIEMENSBUTTONFUNCTION_CAFGPUNAVAIL			0x80000079
#define SIEMENSBUTTONFUNCTION_CAFFORWARD			0x8000007A
#define SIEMENSBUTTONFUNCTION_CAFFORWARDCAN			0x8000007B
#define SIEMENSBUTTONFUNCTION_T_VARFWDALL			0x8000007C
#define SIEMENSBUTTONFUNCTION_T_VARFWDBUSY			0x8000007D
#define SIEMENSBUTTONFUNCTION_T_VARFWDNA			0x8000007E
#define SIEMENSBUTTONFUNCTION_T_FIXFWDALL			0x8000007F
#define SIEMENSBUTTONFUNCTION_T_FIXFWDBUSY			0x80000080
#define SIEMENSBUTTONFUNCTION_T_FIXFWDNA			0x80000081
#define SIEMENSBUTTONFUNCTION_CODECALL				0x80000082
#define SIEMENSBUTTONFUNCTION_MSGRSUMMON			0x80000083
#define SIEMENSBUTTONFUNCTION_CALLRCDSILENT			0x80000084
#define SIEMENSBUTTONFUNCTION_STOPHUNT				0x80000085
#define SIEMENSBUTTONFUNCTION_XFERPUSHPULL			0x80000086
#define SIEMENSBUTTONFUNCTION_PARKGROUP				0x80000087
#define SIEMENSBUTTONFUNCTION_VOICECALL				0x80000088
#define SIEMENSBUTTONFUNCTION_SECRXFER				0x80000089
#define SIEMENSBUTTONFUNCTION_SECRINTERCEPT			0x8000008A
#define SIEMENSBUTTONFUNCTION_SECRPICKUP			0x8000008B
#define SIEMENSBUTTONFUNCTION_TIMEDREMINDER			0x8000008C
#define SIEMENSBUTTONFUNCTION_FIXEDCONFGROUP			0x8000008D
#define SIEMENSBUTTONFUNCTION_INTERCOMGROUP			0x8000008E
#define SIEMENSBUTTONFUNCTION_SPEEDSYSGROUP			0x8000008F
#define SIEMENSBUTTONFUNCTION_TAFAS				0x80000090
#define SIEMENSBUTTONFUNCTION_PICKUPGROUP			0x80000091
#define SIEMENSBUTTONFUNCTION_PARKINTERCOM			0x80000092
#define SIEMENSBUTTONFUNCTION_RELAYCONTROL			0x80000093
#define SIEMENSBUTTONFUNCTION_PICKUPINTERCOM			0x80000094
#define SIEMENSBUTTONFUNCTION_ACDDONOTDISTURB			0x80000095
#define SIEMENSBUTTONFUNCTION_RELEASETRUNK			0x80000096
#define SIEMENSBUTTONFUNCTION_REJECTCAMPON			0x80000097
#define SIEMENSBUTTONFUNCTION_PICKUPCAMPON			0x80000098
#define SIEMENSBUTTONFUNCTION_CALLWAITINGACT			0x80000099
#define SIEMENSBUTTONFUNCTION_CAMPONMANUAL			0x8000009A
#define SIEMENSBUTTONFUNCTION_DIRECTEDPICKUP			0x8000009B
#define SIEMENSBUTTONFUNCTION_CODELOCK				0x8000009C
#define SIEMENSBUTTONFUNCTION_GETERRORS				0x8000009D
#define SIEMENSBUTTONFUNCTION_GETCHARGES			0x8000009E
#define SIEMENSBUTTONFUNCTION_CLIR				0x8000009F
#define SIEMENSBUTTONFUNCTION_MONITORRLINE			0x800000A0
#define SIEMENSBUTTONFUNCTION_SERVICE_MENU			0x800000A1
#define SIEMENSBUTTONFUNCTION_MENU_SELECT			0x800000A2
#define SIEMENSBUTTONFUNCTION_MENU_FWD				0x800000A3
#define SIEMENSBUTTONFUNCTION_MENU_BWD				0x800000A4
#define SIEMENSBUTTONFUNCTION_MALICIOUSCALLID			0x800000A5
#define SIEMENSBUTTONFUNCTION_LASTCALLS				0x800000A6
#define SIEMENSBUTTONFUNCTION_LEAVEMESSAGE			0x800000A7
#define SIEMENSBUTTONFUNCTION_FIXFWDTRUNK			0x800000A8
#define SIEMENSBUTTONFUNCTION_DIRECTORY				0x800000A9
#define SIEMENSBUTTONFUNCTION_DUPLEXVOICECALLPROTECTION		0x800000AA
#define SIEMENSBUTTONFUNCTION_RETRIEVECALL			0x800000AB
#define SIEMENSBUTTONFUNCTION_DOOR				0x800000AC
#define SIEMENSBUTTONFUNCTION_DTMF				0x800000AD
#define SIEMENSBUTTONFUNCTION_MONITORROOM			0x800000AE
#define SIEMENSBUTTONFUNCTION_NET_A				0x800000AF
#define SIEMENSBUTTONFUNCTION_NET_B				0x800000B0
#define SIEMENSBUTTONFUNCTION_ASSOCIATEDDIALING			0x800000B1
#define SIEMENSBUTTONFUNCTION_ASSOCIATEDSERVICE			0x800000B2
#define SIEMENSBUTTONFUNCTION_SHOWWAITINGCALLS			0x800000B3
// reserved:
//								0x800000B4
//								0x800000B5
//								0x800000B6
//								0x800000B7
#define SIEMENSBUTTONFUNCTION_SPKRONEBCAST			0x800000B8
#define SIEMENSBUTTONFUNCTION_ADL1				0x800000B9
#define SIEMENSBUTTONFUNCTION_ADL2				0x800000BA
#define SIEMENSBUTTONFUNCTION_ADL3				0x800000BB
#define SIEMENSBUTTONFUNCTION_ADL4				0x800000BC
#define SIEMENSBUTTONFUNCTION_AUTOICOM				0x800000BD
#define SIEMENSBUTTONFUNCTION_TMMS				0x800000BE
#define SIEMENSBUTTONFUNCTION_CAMPMSGS				0x800000BF
#define SIEMENSBUTTONFUNCTION_GROUPPICK				0x800000C0
#define SIEMENSBUTTONFUNCTION_MSGWAITCTRL			0x800000C1
#define SIEMENSBUTTONFUNCTION_MSGWAIT				0x800000C2
#define SIEMENSBUTTONFUNCTION_SPKRONEWAY			0x800000C3
#define SIEMENSBUTTONFUNCTION_ADK				0x800000C4
#define SIEMENSBUTTONFUNCTION_DSSKEY				0x800000C5
#define SIEMENSBUTTONFUNCTION_AGTMODEAVL			0x800000C6
#define SIEMENSBUTTONFUNCTION_AGTMODEUNAV			0x800000C7
#define SIEMENSBUTTONFUNCTION_AGTMODEWRK			0x800000C8
#define SIEMENSBUTTONFUNCTION_MANANS				0x800000C9
#define SIEMENSBUTTONFUNCTION_ACDAGTMSG				0x800000CA
#define SIEMENSBUTTONFUNCTION_ACDSUPMSG				0x800000CB
#define SIEMENSBUTTONFUNCTION_ACDEMERMSG			0x800000CC
#define SIEMENSBUTTONFUNCTION_ACDMONSLNT			0x800000CD
#define SIEMENSBUTTONFUNCTION_ACDMONTONE			0x800000CE
#define SIEMENSBUTTONFUNCTION_ACDPRIGRP				0x800000CF
#define SIEMENSBUTTONFUNCTION_ACDSECGRP				0x800000D0
#define SIEMENSBUTTONFUNCTION_ACDPRIQUE				0x800000D1
#define SIEMENSBUTTONFUNCTION_ACDSECQUE				0x800000D2
#define SIEMENSBUTTONFUNCTION_PROGRAM				0x800000D3
#define SIEMENSBUTTONFUNCTION_MAILBOX				0x800000D4
#define SIEMENSBUTTONFUNCTION_HEADSET				0x800000D5
#define SIEMENSBUTTONFUNCTION_CALLBACKKEY			0x800000D6
#define SIEMENSBUTTONFUNCTION_PHONEMAIL				0x800000D7
#define SIEMENSBUTTONFUNCTION_PRIVACY				0x800000D8
#define SIEMENSBUTTONFUNCTION_TOGGLE				0x800000D9
#define SIEMENSBUTTONFUNCTION_DATAKEY				0x800000DA
#define SIEMENSBUTTONFUNCTION_DDSLOCAL				0x800000DB
#define SIEMENSBUTTONFUNCTION_ACCTNUM				0x800000DC
#define SIEMENSBUTTONFUNCTION_AGTLOGON				0x800000DD
#define SIEMENSBUTTONFUNCTION_ACDMSGACK				0x800000DE
#define SIEMENSBUTTONFUNCTION_ACDMSGSCROLL			0x800000DF
#define SIEMENSBUTTONFUNCTION_BUZZPRESET			0x800000E0
#define SIEMENSBUTTONFUNCTION_COSCHANGE				0x800000E1
#define SIEMENSBUTTONFUNCTION_VARFWDALLINT			0x800000E2
#define SIEMENSBUTTONFUNCTION_VARFWDALLEXT			0x800000E3
#define SIEMENSBUTTONFUNCTION_VARFWDBOTH			0x800000E4
#define SIEMENSBUTTONFUNCTION_VARFWDBUSY			0x800000E5
#define SIEMENSBUTTONFUNCTION_VARFWDNA				0x800000E6
#define SIEMENSBUTTONFUNCTION_VARFWDBUSYNA			0x800000E7
#define SIEMENSBUTTONFUNCTION_VARFWDCANCEL			0x800000E8
#define SIEMENSBUTTONFUNCTION_FIXFWDACT				0x800000E9
#define SIEMENSBUTTONFUNCTION_FIXFWDCAN				0x800000EA
#define SIEMENSBUTTONFUNCTION_PVTHOLD				0x800000EB
#define SIEMENSBUTTONFUNCTION_STORE				0x800000EC
#define SIEMENSBUTTONFUNCTION_BADTRUNK				0x800000ED
#define SIEMENSBUTTONFUNCTION_SPKRFIXONE			0x800000EE
#define SIEMENSBUTTONFUNCTION_SPKRTWOWAY			0x800000EF
#define SIEMENSBUTTONFUNCTION_SPKRREJECT			0x800000F0
#define SIEMENSBUTTONFUNCTION_START				0x800000F1
// unused:
//								0x800000F2
//								0x800000F3
//								0x800000F4
#define SIEMENSBUTTONFUNCTION_SYSSPEEDGP2			0x800000F5
#define SIEMENSBUTTONFUNCTION_LINEKEY				0x800000F6
#define SIEMENSBUTTONFUNCTION_OVERRIDE				0x800000F7
#define SIEMENSBUTTONFUNCTION_CLEAR				0x800000F8
#define SIEMENSBUTTONFUNCTION_CANCEL				0x800000F9
#define SIEMENSBUTTONFUNCTION_DTS				0x800000FA
#define SIEMENSBUTTONFUNCTION_INUSEKEY				0x800000FB
#define SIEMENSBUTTONFUNCTION_REPEATID				0x800000FC
#define SIEMENSBUTTONFUNCTION_ROLMPARK				0x800000FD
#define SIEMENSBUTTONFUNCTION_CONFREMLAST			0x800000FE
#define SIEMENSBUTTONFUNCTION_CALLWTG				0x800000FF


//------------------------------------------------------------------------------
// Additional literals
//------------------------------------------------------------------------------

// possible values for dwRequestType in SIEMENS_LINE_DEV_SPECIFIC
#define SIEMENSLINE_DIAL_DIGITS			0x00000001  //dials digits
#define SIEMENSLINE_GET_FEATURELIST		0x00000002  //Get previously got FeatureList
#define SIEMENSLINE_SET_HLB_PROGRAMKEY		0x00000003  //Set speedkey
#define SIEMENSLINE_SET_OPTISET_TYPE		0x00000004  //Set type of optiset
#define SIEMENSLINE_REQ_FEATURE_STATES		0x00000005  //requests the transmission of feature states
#define SIEMENSLINE_PARK_DIRECT			0x00000006  //parks a call to a specific station
#define SIEMENSLINE_GET_PUSKEYINFO		0x00000007  //Get infos about a PUS key
#define SIEMENSLINE_PRESS_PUSKEY		0x00000008  //Press a specific PUS key
#define SIEMENSLINE_SET_HEADSET			0x00000009  //set/unset headset support
#define SIEMENSLINE_GET_SYSPARKSLOTS		0x0000000A  //get the occupancy of all system park slots

// possible values for dwParam1 in LINE_DEVSPECIFIC
#define SIEMENSLINE_FEATURELIST_COMPLETE	0x00000000
#define SIEMENSLINE_LM_ACK			0x00000001
#define SIEMENSLINE_LM_REJECT			0x00000002
#define SIEMENSLINE_LED_STATE_CHANGED		0x00000003
#define SIEMENSLINE_PARKINFO			0x00000004  //provide the slot which was used to parked a call on it
#define SIEMENSLINE_PARKSLOTSTATE		0x00000005  //provide the (occupancy) status of all system park slots
#define SIEMENSLINE_DFP_STATES_CHANGED		0x8000FFFF

//constants for Optiset-Type
#define SIEMENSLINE_OPTISET_TYPE_BASIC		1  //"optiset E basic"
#define SIEMENSLINE_OPTISET_TYPE_ADVANCE	2  //Hicom 300 US specific "optiSet advance"
#define SIEMENSLINE_OPTISET_TYPE_COMFORT	3  //also known as "optiSet advance plus"
#define SIEMENSLINE_OPTISET_TYPE_MEMORY		4  //"optiset E memory"
#define SIEMENSLINE_OPTIPOINT500_TYPE_BASIC	5  //"optiPoint 500 basic"
#define SIEMENSLINE_OPTIPOINT500_TYPE_STANDARD	6  //"optiPoint 500 standard"
#define SIEMENSLINE_OPTIPOINT500_TYPE_ADVANCE	7  //"optiPoint 500 advance"
#define SIEMENSLINE_OPTIPOINT600_TYPE_OFFICE	8  //"optiPoint 600 office"
#define SIEMENSLINE_OPTIPOINT410_TYPE_ENTRY	11 //"optiPoint 410 entry"
#define SIEMENSLINE_OPTIPOINT410_TYPE_ECONOMY	12 //"optiPoint 410 economy"
#define SIEMENSLINE_OPTIPOINT410_TYPE_STANDARD	13 //"optiPoint 410 standard"
#define SIEMENSLINE_OPTIPOINT410_TYPE_ADVANCE	14 //"optiPoint 410 advance"

// the number of digits allowed in szDialableString[] in SIEMENS_LINE_DEV_SPECIFIC
#define SIEMENS_MAX_DIALABLE_STRING_BYTES	100

//maximum number of features in feature-list
#define SIEMENS_MAX_FEATURES			256
//"*123" + 0x00
#define SIEMENS_FEATURE_LENGTH			5

#define SIEMENS_MAX_RUFNR_LEN			9

// The number of bitmasks required in an array to represent each button function with a bit
#define SIEMENS_NUM_BUTTONFCN_BITMASKS		8

// possible values for dwProgramState in SIEMENS_PHONESTATUS_DEV_SPECIFIC
#define SIEMENSPROGRAMSTATE_DEACTIVATED		0L
#define SIEMENSPROGRAMSTATE_ACTIVATED		1L
#define SIEMENSPROGRAMSTATE_SYSTEMUSER		1L
#define SIEMENSPROGRAMSTATE_SYSTEMHOST		2L
#define SIEMENSPROGRAMSTATE_USER 		3L



//------------------------------------------------------------------------------
// Ring Modes
//------------------------------------------------------------------------------

#define SIEMENSRINGMODE_SILENCE			0

#define SIEMENSRINGMODE_SINGLE_RING_INTERN	1
#define SIEMENSRINGMODE_SINGLE_RING		1

#define SIEMENSRINGMODE_DBL_RING_EXTERNAL	2
#define SIEMENSRINGMODE_DBL_RING		2

#define SIEMENSRINGMODE_TPL_RING_RECALL		3
#define SIEMENSRINGMODE_TPL_RING		3

#define SIEMENSRINGMODE_SINGLE_BUZZ_ALERT	4
#define SIEMENSRINGMODE_SINGLE_BUZZ		4

#define SIEMENSRINGMODE_COM_RING		5

#define SIEMENSRINGMODE_TPL_BUZ_DATA_CALL	6
#define SIEMENSRINGMODE_TPL_BUZZ		6

#define SIEMENSRINGMODE_CONT_RING_EMERGCY	7
#define SIEMENSRINGMODE_CONT_RING		7

#define SIEMENSRINGMODE_DOUBLE_BUZZ_NOTIFY	8

#define SIEMENSRINGMODE_DOUBLE_BUZZ		9

#define SIEMENSRINGMODE_RESERVED		10

#define SIEMENSRINGMODE_UNKNOWN			11



//------------------------------------------------------------------------------
// Structure Definitions
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// SIEMENS_LINE_DEV_SPECIFIC: Applications pass this device-specific structure
//				to the lineDevSpecific() routine.
// dwRequestType[] - possible values:
//------------------------------------------------------------------------------
//	SIEMENSLINE_DIAL_DIGITS tells lineDevSpecific() to send the digits in
//				szDialableString[] to the phone.
//
//		szDialableString [] - a Null-terminated ASCII string of dialable
//				digits in the range of (0..9, *, #), which should
//				be sent to the phone.
//------------------------------------------------------------------------------
//	SIEMENSLINE_GET_FEATURELIST returns the availability of the provided features
//
//		bFeatureListAvailable - an indicator, if the initial feature state
//				transmission was done and if the following strings
//				are filled or not
//
//		szStaticFeatureListGlobal[] - provides the feature availability
//				of global features
//
//		szStaticFeatureListSpecific[] - provides the feature availability
//				of system specific features
//------------------------------------------------------------------------------
//	SIEMENSLINE_SET_HLB_PROGRAMKEY programs a virtual station keys on the
//				HG1500 (HiPath 3000 specific)
//
//		iKeyIndex - index of the programable virtual key
//
//		szIntNumber - internal station (destination) number
//------------------------------------------------------------------------------
//	SIEMENSLINE_SET_OPTISET_TYPE changes the configured device type from the
//				applications side
//
//		dwOptisetType - device type
//------------------------------------------------------------------------------
//	SIEMENSLINE_REQ_FEATURESTATES requests DEV_SPECIFIC events for every
//				change on a feature state
//
//		bSwitch - switch, if functionality should be ON or OFF
//------------------------------------------------------------------------------
//	SIEMENSLINE_PARK_DIRECT parks a call to a specific station
//
//		szParkSTNNo [] - a Null-terminated ASCII string of dialable digits
//				in the range of (0..9, *, #), which should be sent
//				to the phone as park destination no.
//------------------------------------------------------------------------------
//	SIEMENSLINE_GET_PUSKEYINFO gets infos about a PUS key
//
//		iPUSKeyNo - index of the available PUS keys
//		bDevice - device identifier regarding the device on which the PUS key is configured
//		bKeyNo - key identifier regarding the physical key on which the PUS key is configured
//		szSTNNo [] - a Null-terminated ASCII string of the PUS key related station no.
//		szSTNName [] - a Null-terminated ASCII string of the PUS key related station name
//		bState - identifier regarding the status in which the PUS key is actually in
//------------------------------------------------------------------------------
//	SIEMENSLINE_PRESS_PUSKEY presses a specific PUS key
//
//		iPUSKeyNoToPress - index of the available PUS key which is to pressed
//------------------------------------------------------------------------------
//	SIEMENSLINE_SET_HEADSET sets/unsets headset support
//
//		bHSavail - switch, headset support should be ON (TRUE) or OFF (FALSE)
//------------------------------------------------------------------------------
//	SIEMENSLINE_GET_SYSPARKSLOTS get the occupancy of all system park slots
//
//		bPlaceholder - placeholder, should be ON (TRUE) or OFF (FALSE) w/o impact
//------------------------------------------------------------------------------
// NOTE: The max string size may be limited by the service provider. Please consult
// the TSP documentation for this information.
//------------------------------------------------------------------------------


typedef struct _SIEMENS_LINE_DEV_SPECIFIC
{
   DWORD dwRequestType;
	
   union
   {
      //dwRequestType == SIEMENSLINE_DIAL_DIGITS
      BYTE szDialableString [SIEMENS_MAX_DIALABLE_STRING_BYTES + 1];
      
      //dwRequestType == SIEMENSLINE_GET_FEATURELIST
      struct
      {
         BOOL bFeatureListAvailable;
         char szStaticFeatureListGlobal[SIEMENS_MAX_FEATURES/8];
         char szStaticFeatureListSpecific[SIEMENS_MAX_FEATURES/8];
      };

      //dwRequestType == SIEMENSLINE_SET_HLB_PROGRAMKEY
      struct
      {
         INT  iKeyIndex;
         char szIntNumber[SIEMENS_MAX_RUFNR_LEN];
      };

      //dwRequestType == SIEMENSLINE_SET_OPTISET_TYPE
      DWORD dwOptisetType;

      //dwRequestType == SIEMENSLINE_REQ_FEATURE_STATES
      BOOL bSwitch;

      //dwRequestType == SIEMENSLINE_PARK_DIRECT
      BYTE szParkSTNNo [SIEMENS_MAX_DIALABLE_STRING_BYTES + 1];

      //dwRequestType == SIEMENSLINE_GET_PUSKEYINFO
      struct
      {
		 INT	iPUSKeyNo;
		 BYTE	bDevice;
		 BYTE	bKeyNo;
		 char	szSTNNo[7];
		 char	szSTNName[50];
		 BYTE	bState;
      };

      //dwRequestType == SIEMENSLINE_PRESS_PUSKEY
	  INT	iPUSKeyNoToPress;

      //dwRequestType == SIEMENSLINE_SET_HEADSET
      BOOL bHSavail;

      //dwRequestType == SIEMENSLINE_GET_SYSPARKSLOTS
      BOOL bPlaceholder;
   };
}
SIEMENS_LINE_DEV_SPECIFIC, FAR *LPSIEMENS_LINE_DEV_SPECIFIC;


//------------------------------------------------------------------------------
// SIEMENS_LINEDEVCAPS_DEV_SPECIFIC
//
// The device specific portion of the LINEDEVCAPS structure contains the
// following device specific data:
//
//   dwDevSpecificRequestsAvailable - A bitmask of available requests
//      that may be passed to lineDevSpecific() in the dwRequestType
//      field of the SIEMENS_LINE_DEV_SPECIFIC structure. The possible
//      bit(s) that may be set:
//          SIEMENSLINE_DIAL_DIGITS
//
//   dwInvokableButtonsBitmasks[] - An array of bitmasks indicating which
//      PHONEBUTTONFUNCTIONs may be invoked via lineDevSpecificFeature().
//      Note: this is the static availability of the feature as opposed
//      to the dynamic availability of the feature based on the current
//      state of the device. The dynamic feature availability is found
//      in the device specific portion of the LINEDEVSTATUS structure.
//      The PHONEBUTTONFUNCTION value is the zero-based bit position in 
//      the bitmask, and the bit is set if the function may be invoked.
//
//------------------------------------------------------------------------------
typedef struct _SIEMENS_LINEDEVCAPS_DEV_SPECIFIC
{
	DWORD dwDevSpecificRequestsAvailable;
	DWORD dwInvokableButtonsBitmasks [SIEMENS_NUM_BUTTONFCN_BITMASKS];
}
SIEMENS_LINEDEVCAPS_DEV_SPECIFIC, FAR *LPSIEMENS_LINEDEVCAPS_DEV_SPECIFIC;


//------------------------------------------------------------------------------
// SIEMENS_LINEDEVSTATUS_DEV_SPECIFIC
//
// The device specific portion of the LINEDEVSTATUS structure contains the
// following device specific data:
//
//   dwInvokableButtonsBitmasks[] - An array of bitmasks indicating which
//      PHONEBUTTONFUNCTIONs may currently be invoked by 
//      lineDevSpecificFeature() based on the current state of the device.
//      The PHONEBUTTONFUNCTION value is the zero-based bit position in
//      the bitmask, and the bit is set if the function may be invoked.
//
//------------------------------------------------------------------------------
typedef struct _SIEMENS_LINEDEVSTATUS_DEV_SPECIFIC
{
    DWORD       dwInvokableButtonsBitmasks [SIEMENS_NUM_BUTTONFCN_BITMASKS];
    
} SIEMENS_LINEDEVSTATUS_DEV_SPECIFIC, FAR* LPSIEMENS_LINEDEVSTATUS_DEV_SPECIFIC;


//------------------------------------------------------------------------------
// SIEMENS_PHONESTATUS_DEV_SPECIFIC:
//
// Structure for Device Specific extension to the PHONESTATUS structure.
//
//------------------------------------------------------------------------------
typedef struct _SIEMENS_PHONESTATUS_DEV_SPECIFIC
{
    DWORD       dwProgramState;
    DWORD       dwVirtualButtonSize;
    DWORD       dwVirtualButtonOffset;
}
SIEMENS_PHONESTATUS_DEV_SPECIFIC, FAR *LPSIEMENS_PHONESTATUS_DEV_SPECIFIC;


//------------------------------------------------------------------------------

#pragma pack(pop, include_siemens)	// restore previos packing alingment

#endif // __SIEMENS_H__
